unit System;

interface

procedure _InitExe;
procedure _HandleFinally;
procedure _halt0;

type
  TGUID = record
    D1: LongWord;
    D2: Word;
    D3: Word;
    D4: array[0..7] of Byte;
  end;

type
  TFNExitProcess = procedure(uExitCode: LongWord); stdcall;

var
  Kernel32: LongWord;
  ExitCode: LongWord;
  ExitProcess: TFNExitProcess;

function LoadLibrary(lpLibFileName: PChar): LongWord; stdcall; external 'kernel32.dll' name 'LoadLibraryA';
function GetProcAddress(hModule: LongWord; lpProcName: PChar): Pointer; stdcall; external 'kernel32.dll';

implementation

procedure _InitExe;
const
  PExitProcess: PChar = 'ExitProcess';
  PKernel32: PChar = 'kernel32.dll';
asm
  push PExitProcess
  push PKernel32
  call LoadLibrary
  mov  Kernel32, eax
  push eax
  call GetProcAddress 
  mov  ExitProcess, eax
end;

procedure _HandleFinally;
asm
end;

procedure _halt0;
asm
  push ExitCode
  call ExitProcess
end;

end.
